---
# This role setup journalbeat; a log exporter to elastic stack (using logstash receiver)

- name: Install journalbeat
  import_tasks: install.yml
  when: journalbeat_state == 'present'

- name: Ensure journalbeat is enabled and started
  become: yes
  service:
    name: journalbeat
    enabled: yes
    state: started
  when: journalbeat_state == 'present'

- name: Ensure journalbeat is disabled and stopped
  become: yes
  service:
    name: journalbeat
    enabled: False
    state: stopped
  when: journalbeat_state == 'absent'
  ignore_errors: True

- name: Ensure journalbeat configuration directory exists
  become: yes
  file:
    state: directory
    owner: root
    group: root
    path: "{{ journalbeat_configuration_directory }}"
    mode: u=rwx,g=,o=
  when: journalbeat_state == 'present'

- name: Configure TLS logstash/journalbeat certificates
  import_tasks: certificates.yml
  when: journalbeat_state == 'present'

- name: Copy journalbeat configuration
  become: yes
  template:
    src: templates/journalbeat.j2.yml
    dest: "{{ journalbeat_configuration_directory }}/journalbeat.yml"
    owner: root
    group: root
    mode: u=rw,g=,o=
  notify:
    - restart journalbeat
  when: journalbeat_state == 'present'
